@Controller
@RequestMapping("/mvc/todos")
@SessionAttributes("TodoList")
public class ToDoController {
    @RequestMapping(value = "/", method = RequestMethod.GET)
    public String index(ModelMap model) {
        ListModelList<Todo> todoList = new ListModelList<Todo>();
        TodoList.add(new Todo("Rising early"));
        TodoList.add(new Todo("Booking of a restaurant for breakfast"));
        TodoList.add(new Todo("Visit technical office"));
        model.addAttribute(TodoList);
        return "forward:list";
    }
    @RequestMapping(value = "/finish", method = RequestMethod.POST)
    public String finish(@ZKVariable("self.value") Todo todo) {
        todo.setDone(!todo.isDone());
        return ZKModelAndView.SELF; // meaning the view is handled by ZK way.
    }
    @RequestMapping(value = "/list", method = {RequestMethod.GET,RequestMethod.POST})
    public String list() {
        return "mvc/list.zul";
    }
    @RequestMapping(value = "/add", method = RequestMethod.POST)
    public String add(
            @ModelAttribute("TodoList") ListModelList<Todo> TodoList,
            @ZKSelector("#message") String message) {
        TodoList.add(new Todo(message));
        return "forward:list";
    }
    @RequestMapping(value = "/edit", method = RequestMethod.POST)
    public String edit(
            @ModelAttribute("TodoList") ListModelList<Todo> TodoList,
            @ZKSelector("#status") Label status,
            @ZKSelector("#message") Textbox message,
            @ZKSelector("#submit") Button submit) {
        // getting the currently selected item
        Todo editTodo = TodoList.getSelection().iterator().next();
        message.setValue(editTodo.getMessage());
        status.setValue("Edit:");
        submit.setLabel("Update");
        submit.setClientDataAttribute("springmvc-action", "update"); // change to mapping to '/update'
        return ZKModelAndView.SELF;
    }
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    public String update(
            @ModelAttribute("TodoList") ListModelList<Todo> TodoList,
            @ZKSelector("#status") Label status,
            @ZKSelector("#message") String message,
            @ZKSelector("#submit") Button submit) {
        Todo editTodo = TodoList.getSelection().iterator().next();
        editTodo.setMessage(message);
        status.setValue("Add:");
        submit.setLabel("Add new Todo");
        submit.setClientDataAttribute("springmvc-action", "add");
        //saving to the model
        TodoList.update(editTodo);
        return "forward:list";
    }
}
